config/routes.rb
Hydra::Application.routes.draw do
  namespace :aeon do
    resources :queues do
      collection do
        get 'errors'
        delete 'clear_errors'
      end
    end
    resources :requests do
      member do
        get 'set_to_new'
        get 'set_to_expire'
        get 'set_to_in_process'
        get 'set_to_new'
        get 'set_to_active'
      end
    end
  end

  get 'work_authorizations', to: 'work_authorizations#index', :as => 'work_authorizations'

  resources :audits, :only => [:index, :show]
  resources :pages
  get '/p/:id', to: 'pages#view', :as => 'view_page'

  resources :contact_forms, :only => [:new, :response]
  get 'contact' => 'contact_forms#new'
  get 'contact_response' => 'contact_forms#response'

  mount Qa::Engine => '/qa'

  root :to => "dams_units#index"
  resources :collection, :only => [:show], :controller => 'dams_collections', :as => 'dams_collections' do
    member do
      get 'dams42'
      get 'data'
      get 'ezid'
      get 'ezid_update'
      get 'ezid_batch'
      get 'ezid_batch_update'
      get 'rdf'
      get 'rdf_nt'
      get 'rdf_ttl'
      get 'osf_api'
      get 'osf_push'
      get 'osf_delete'
      get 'osf_data'
    end
  end

  get '/dlp', to: 'dams_units#show', :id => 'dlp'
  get '/rdcp', to: 'dams_units#show', :id => 'rdcp'
  get '/:id/collections', to: 'catalog#collection_search', :as => "dams_unit_collections"
  get '/solrdoc/:id', to: 'catalog#solrdoc', :as => "solrdoc"
  get "collections", :to => 'catalog#collection_search', :as => 'dams_collections'

  Blacklight.add_routes(self, :except => [:solr_document, :catalog]  )

  get 'search/opensearch', :as => "opensearch_catalog"
  get 'search/citation', :as => "citation_catalog"
  get 'search/email', :as => "email_catalog"
  get 'search/sms', :as => "sms_catalog"
  get 'search/endnote', :as => "endnote_catalog"
  get 'search/send_email_record', :as => "send_email_record_catalog"
  get "search/facet/:id", :to => 'catalog#facet', :as => 'catalog_facet'
  get "search", :to => 'catalog#index', :as => 'catalog_index'
  get 'search/:id/librarian_view', :to => "catalog#librarian_view", :as => "librarian_view_catalog"
  resources :solr_document, :path => 'search', :controller => 'catalog', :only => [:show, :update]
  resources :catalog, :only => [:show, :update]

  devise_for :users, skip: [:sessions], :controllers => { :omniauth_callbacks => "users/omniauth_callbacks", :passwords => 'passwords' }

  devise_scope :user do
    get '/users/sign_in', :to => "users/sessions#new", :as => :new_user_session
    get '/users/sign_out', :to => "users/sessions#destroy", :as => :destroy_user_session
    get '/users/auth_link', :to => "users/sessions#new_auth_link", :as => :new_auth_link
    post '/users/auth_link/create', :to => "users/sessions#create_auth_link", :as => :create_auth_link
  end

  resources :dams_subjects, :only => [:show]

  resources :object, :controller => 'dams_objects', :as => 'dams_objects', only: [:index, :show] do
    member do
      get 'dams42'
      get 'data'
      get 'ezid'
      get 'ezid_update'
      get 'rdf'
      get 'rdf_nt'
      get 'rdf_ttl'
    end
  end

  post "object/:id/deriv/:ds", :to => 'file#deriv', :as => 'deriv'
  get "object/:id/zoom/:cmp", :to => 'dams_objects#zoom', :as => 'zoom'

  get "embed/:id/:cmp", :to => 'dams_objects#embed', :as => 'embed'

  get "object/:id/edit", :to => 'dams_objects#edit', :as => 'edit'
  put "object/:id", :to => 'dams_objects#update', :as => 'update'
  get "object/:id/:ds", :to => 'file#show', :constraints => { :ds => /[^\/]+/ }, :as => 'file'
  get "object/:id/:ds/download", :to => 'file#show', defaults: { disposition: 'attachment' }, :constraints => { :ds => /[^\/]+/ }, :as => 'download'
  resources :dams_assembled_collections, only: [:index, :show]
  resources :dams_units, only: [:index, :show] do
    member do
      get 'collections'
    end
  end
  resources :dams_copyrights, only: [:index, :show]
  resources :dams_licenses, only: [:index, :show]
  resources :dams_other_rights, only: [:index, :show]
  resources :dams_statutes, only: [:index, :show]
  resources :dams_languages, only: [:index, :show]
  resources :dams_vocabularies, only: [:index, :show]
  resources :dams_roles, only: [:index, :show]
  resources :dams_provenance_collections, only: [:index, :show]
  resources :dams_provenance_collection_parts, only: [:index, :show]
  resources :dams_vocabulary_entries, only: [:index, :show]
  resources :dams_source_captures, only: [:index, :show]
  resources :dams_cartographics, only: [:index, :show]
  resources :dams_built_work_places, only: [:index, :show]
  resources :dams_iconographies, only: [:index, :show]
  resources :dams_style_periods, only: [:index, :show]
  resources :dams_scientific_names, only: [:index, :show]
  resources :dams_techniques, only: [:index, :show]
  resources :dams_cultures, only: [:index, :show]
  resources :dams_cultural_contexts, only: [:index, :show]
  resources :dams_functions, only: [:index, :show]
  resources :dams_related_resources, only: [:index, :show]
  resources :mads_personal_names, only: [:index, :show]
  resources :mads_family_names, only: [:index, :show]
  resources :mads_corporate_names, only: [:index, :show]
  resources :mads_conference_names, only: [:index, :show]
  resources :mads_complex_subjects, only: [:index, :show]
  resources :mads_topics, only: [:index, :show]
  resources :mads_temporals, only: [:index, :show]
  resources :mads_names, only: [:index, :show]
  resources :mads_occupations, only: [:index, :show]
  resources :mads_genre_forms, only: [:index, :show]
  resources :mads_geographics, only: [:index, :show]
  resources :mads_schemes, only: [:index, :show]
  resources :mads_authority, :as => 'mads_authorities', only: [:index, :show]
  resources :mads_languages, only: [:index, :show]
  resources :dams_lithologies, only: [:index, :show]
  resources :dams_series, only: [:index, :show]
  resources :dams_cruises, only: [:index, :show]
  resources :dams_anatomies, only: [:index, :show]

  resources :get_data do
  get 'get_linked_data', :on => :member
  post 'get_linked_data', :on => :member
  get 'get_name', :on => :member
  post 'get_name', :on => :member
  get 'get_subject', :on => :member
  post 'get_subject', :on => :member
  get 'get_creator', :on => :member
  post 'get_creator', :on => :member
  get 'get_ark', :on => :member
  get 'get_new_objects'
  get 'get_dams_data', :on => :member
  post 'get_dams_data', :on => :member

  end

  get 'collection_options/default_sort' => 'collection_options#default_sort', :as => :collection_sort
  
  resources :random

  get '/ruby-version' => 'application#ruby_version'

end

app/models/mads_family_name.rb
class MadsFamilyName < ActiveFedora::Base
  has_metadata 'damsMetadata', :type => MadsFamilyNameDatastream 
  has_attributes :name, :elementList, :externalAuthority, :variant, :hasVariant_attributes, :hiddenVariant,
    :scheme, :scheme_attributes,
    :nameElement, :nameElement_attributes, :nameValue,
    :givenNameElement, :givenNameElement_attributes, :givenNameValue,
    :fullNameElement, :fullNameElement_attributes, :fullNameValue,
    :familyNameElement, :familyNameElement_attributes, :familyNameValue,
    :dateNameElement, :dateNameElement_attributes, :dateNameValue,
    :termsOfAddressNameElement, :termsOfAddressNameElement_attributes, :termsOfAddressNameValue, datastream: :damsMetadata, multiple: true
end

app/controllers/mads_family_names_controller.rb
class MadsFamilyNamesController < ApplicationController
  include Blacklight::Catalog
  include Dams::ControllerHelper
  load_and_authorize_resource
  skip_load_and_authorize_resource :only => [:index, :show]

  ##############################################################################
  # solr actions ###############################################################
  ##############################################################################
  def show
    parm={ :q => "id_t:#{params[:id]}" }
    @document = get_single_doc_via_search(1,parm)
    @current_family_name = @document['name_tesim']
    #@carousel_resp, @carousel = get_search_results( :q => "title_tesim:carousel AND id_t:#{params[:id]}", :qt=>"standard")
     @carousel_resp, @carousel = get_search_results( :q => "title_tesim:carousel")
  end
  def index
    # hydra index
    #@mads_family_names = MadFamilyName.all( :order=>"system_create_dtsi asc" )

    # solr index
    @response, @document = get_search_results(:q => 'has_model_ssim:"info:fedora/afmodel:MadsFamilyName"' )
    @carousel_resp, @carousel = get_search_results( :q => "title_tesim:carousel")
  end

end

app/views/mads_family_names/_browse_facet_link.html.erb
<li><%= link_to "<i class='icon-eye-open'></i> #{facet.label}".html_safe, catalog_facet_path(facet.field, :'facet.sort' => 'index'), :class => "btn btn-block  btn-link" %></li>

app/views/mads_family_names/_family_name_links.html.erb
<li><%= link_to mads_family_name['name_tesim'], mads_family_name %></li>

app/views/mads_family_names/_search_form.html.erb
<%= form_tag catalog_index_url, :method => :get, :class => 'search-query-form clearfix' do %>
	
	<% unless search_fields.empty? %>
		<label for="dams-search" class="hide-text"><%= t('blacklight.search.form.search_field.label') %></label>
		<%= select_tag(:search_field, options_for_select(search_fields, h(params[:search_field])), :class=>"input-block-level", :id=>"dams-search") %>
		<span class="hide-text"><%= t('blacklight.search.form.search_field.post_label') %></span>
	<% end %>

	<label for="q" class="hide-text"><%= t('blacklight.search.form.q') %></label>
	<%= text_field_tag :q, params[:q], :placeholder => "For keywords...", :class => "search_q q input-block-level", :id => "q"%>

	<button type="submit" class="btn btn-inverse pull-right">
		<i class="icon-search icon-white"></i>
		<span><%=t('blacklight.search.form.submit')%></span>
	</button>

<% end %>

app/views/mads_family_names/index.html.erb
<div class="row-fluid">
	<div class="span12">
		<h1>Digital Collections</h1>
	</div>
</div>

<div class="row-fluid">

	<div class="span4">
	
		<div class="well dams-search-box">
			<p>Search</p>
			<%= render_unit_search_bar  %>
		</div>
			
		<p class="sidebar-header"><strong>Family Names</strong></p>
		<% @document.each do |doc| %>
			<% if doc['name_tesim'] != nil %>
				<%= link_to doc['name_tesim'].first, mads_family_name_path(doc['id_t']), :class => "btn btn-block" %>
			<% end %>
		<% end %>

		<p class="sidebar-header"><strong>Browse By </strong></p>
		<ul class="unstyled sidebar-button-list">
			<%= render_browse_facet_links %>
		</ul>
		
		
	
	</div>

</div>

app/views/mads_family_names/show.html.erb
<% @page_title =  "Family Name | #{render_document_show_field_value(:document=>@document, :field=>"name_tesim")} " %>
<% familyName = render_document_show_field_value(:document=>@document, :field=>"name_tesim") %>
<% record_id = render_document_show_field_value(:document=>@document, :field=>"id_t") %>

<div class="row-fluid">

  <div id="content" class="show-document span9">
		<div class="row-fluid">
			<section class="dams-metadata span12">
				<p class="sidebar-header"><strong><%= familyName %></strong></p>			
				<dl class="dl-horizontal">
					<%= render :partial => 'shared/fields/metadata' %>
				</dl>	
			</section>
		</div>
  	  
	 </div>    
	
	<% if(params[:parent_id].nil? and params[:parent_class].nil?) %>		
		<div class="span3">
		
			<div class="well dams-search-box">
				<h4>Search</h4>
				<%= render_unit_search_bar  %>
			</div>
			
			<p class="sidebar-header"><strong>Browse By</strong></p>
			<ul class="unstyled sidebar-button-list">
				<!-- hack in browse by collection, for RCI demo -->
				<li><%= link_to "<i class='icon-eye-open'></i> Collection".html_safe, dams_collections_path(:'f[type_sim]' => 'Collection', :'sort' => 'title_ssi asc'), :class => "btn btn-block  btn-link" %></li>
				<%= render_browse_facet_links %>
			</ul>

	    
					
		</div>
	<% end %>
</div>